VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PSHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IShellExtInit                                            ' shell extension init interface
Implements IShellPropSheetExt                                       ' property sheet shell extension interface

'####################################################################################################
'#####[ IShellExtInit ]##############################################################################
'####################################################################################################
Private Sub IShellExtInit_Initialize(ByVal pidlFolder As Long, ByVal lpDataObject As PropSheetExt.IDataObject, ByVal hKeyProgID As Long)
    ' IShellExtInit_Initialize let us now which files are selected
    '
    Dim udtFormatEtc As FORMATETC                                   ' FORMATETC struct
    Dim udtStgMedium As STGMEDIUM                                   ' STGMEDIUM struct
    Dim sBuff        As String                                      ' buffer for the file path
    Dim lBuff        As Long                                        ' buffer size
    Dim lResult      As Long                                        ' DragQueryFile() result
    Dim i            As Long                                        ' counter
    '                                                               '
    With udtFormatEtc                                               '
        .cfFormat = CF_HDROP                                        '
        .ptd = 0                                                    '
        .dwAspect = DVASPECT_CONTENT                                '
        .lindex = -1                                                '
        .TYMED = TYMED_HGLOBAL                                      '
    End With                                                        '
    '
    If lpDataObject.GetData(udtFormatEtc, udtStgMedium) = S_OK Then ' get the selected files
        modPropSheet.m_FileCount = DragQueryFile(udtStgMedium.pData, _
            &HFFFFFFFF, vbNullString, 0&)                           ' count of selected files
        '
        ReDim modPropSheet.m_FilePath(1 To modPropSheet.m_FileCount) ' redim array to hold file pathes
        '                                                           '
        For i = 0 To modPropSheet.m_FileCount - 1                   ' for each selected file
            lBuff = DragQueryFile(udtStgMedium.pData, i, _
                vbNullString, 0&)                                   ' get the file path len
            '
            sBuff = Space$(lBuff + 1)                               ' prepare the buffer
            '
            lResult = DragQueryFile(udtStgMedium.pData, i, sBuff, _
                lBuff + 1)                                          ' get the file path
            '
            If lResult > 0 Then                                     ' did we get the file path
                modPropSheet.m_FilePath(i + 1) = Left$(sBuff, lResult) ' store the file path
            End If
        Next i
    End If
    '
    If modPropSheet.m_FileCount < 1 Then                            ' no files selected (should never occur)
        ReDim modPropSheet.m_FilePath(0 To 0)                       ' redim the array
    End If
End Sub

'####################################################################################################
'#####[ IShellPropSheetExt_AddPages ]################################################################
'####################################################################################################
Private Sub IShellPropSheetExt_AddPages(ByVal lpfnAddPage As Long, ByVal lParam As Long)
    ' IShellPropSheetExt_AddPages is called to add our page
    '
    Dim udtPropSheetPage As PROPSHEETPAGE                           ' PROPSHEETPAGE struct
    Dim sTitle           As String                                  ' page title
    Dim hPage            As Long                                    ' page handle
    Dim lAddPage         As Long                                    ' AddPage() return value
    '                                                               '
    Const IDD_TXT_EDITOR As Long = 101                              ' dialog id from TxtPropSheetExt.h
    '                                                               '
    If m_FileCount = 1 Then                                         ' only add pages if a single file is selected
        sTitle = "Text bearbeiten"                                  ' page title
        '                                                           '
        With udtPropSheetPage                                       '
            .dwSize = Len(udtPropSheetPage)                         '
            .dwFlags = PSP_USECALLBACK Or PSP_USETITLE              ' page flags
            .hInstance = App.hInstance                              '
            .pszTitle = StrPtr(sTitle)                              ' page title
            .pszTemplate = IDD_TXT_EDITOR                           ' dialog id from TxtPropSheetExt.h
            .pfnDlgProc = GetAddress(AddressOf modDialog.DlgProc)   ' dialog callback proc
            .pfnCallback = GetAddress(AddressOf modPropSheet.PropSheetPageProc) ' property sheet callback proc
        End With                                                    '
        '
        hPage = CreatePropertySheetPage(udtPropSheetPage)           ' create the page
        '                                                           '
        If hPage <> 0 Then                                          ' page created ?
            lAddPage = modASM.AddPage(lpfnAddPage, hPage, lParam)   ' add the page
            '                                                       '
            If lAddPage <> 0 Then                                   ' page added ?
                Set modPropSheet.m_PropSheet = Me                   ' set a reference to this class
            Else                                                    ' else
                DestroyPropertySheetPage lAddPage                   ' destroy the page
            End If                                                  '
        End If                                                      '
    End If                                                          '
End Sub

'####################################################################################################
'#####[ IShellPropSheetExt_ReplacePage ]#############################################################
'####################################################################################################
Private Sub IShellPropSheetExt_ReplacePage(ByVal uPageID As Long, ByVal lpfnReplacePage As Long, ByVal lParam As Long)
    '
    ' This member is only called for control panel pages
    '
    Err.Raise E_NOTIMPL
End Sub

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Function GetAddress(ByVal lpfn As Long)
    GetAddress = lpfn
End Function
