Attribute VB_Name = "modDialog"
Option Explicit
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= APIs
'====================================================================================================
'----------------------------------------------------------------------------------------------------
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, ByVal Source As Long, ByVal Length As Long)
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'----------------------------------------------------------------------------------------------------
'====================================================================================================
'= Const
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private Const WM_DESTROY                As Long = &H2           ' the dialog is destroyed
Private Const WM_NOTIFY                 As Long = &H4E          ' notifies that the Ok, Concel, Apply Now Or Help Button was clicked or that the page was activated or deactivated
Private Const WM_HELP                   As Long = &H53          ' the What's This Help Button is klicked
Private Const WM_INITDIALOG             As Long = &H110         ' the Dialog is initialized
Private Const WM_COMMAND                As Long = &H111         ' a dialog control was clicked
'|
Private Const IDC_TAB                   As Long = 12320         ' found with Spy++
Private Const IDC_EDIT                  As Long = 201           ' Edit Control ID from TxtPropSheetExt.h
'|
Private Const EN_UPDATE                 As Long = &H400         ' send via WM_NOTIFY if the edit control text is about to change
'---------------------------------------------------------------|------------------------------------
'====================================================================================================
'= Variables
'====================================================================================================
'---------------------------------------------------------------|------------------------------------
Private dwHtmlHelpCookie                As Long                 ' needed for HH_INITIALIZE ad HH_UNINITIALIZE
'---------------------------------------------------------------|------------------------------------
'----------------------------------------------------------------------------------------------------



'####################################################################################################
'#####[ DlgProc ]####################################################################################
'####################################################################################################
Public Function DlgProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error Resume Next
    '
    Select Case uMsg                                                        ' select dialog message
        Case WM_INITDIALOG: DlgProc = OnInitDialog(hWnd, wParam, lParam)    ' the dialog is initialized
        Case WM_COMMAND:    DlgProc = OnCommand(hWnd, HiWord(wParam), LoWord(wParam), lParam)
        Case WM_NOTIFY:     DlgProc = OnNotify(hWnd, wParam, lParam)        ' property page button was clicked or page was activated etc.
        Case WM_HELP:       DlgProc = OnHelp(hWnd, lParam)                  ' the what's this help button was clicked
        Case WM_DESTROY:    DlgProc = OnDestroy(hWnd)                       ' the dialog is destroyed
        Case Else:          DlgProc = 0                                     ' default return value
    End Select
End Function

'####################################################################################################
'#####[ OnInitDialog ]###############################################################################
'####################################################################################################
Private Function OnInitDialog(hDialog As Long, hwndFocus As Long, lInitParam As Long) As Long
    'Dim udtPropSheetPage As PROPSHEETPAGE                                  ' not needed
    Dim udtRect          As RECT                                            ' rect of the parent tab
    Dim strText          As String                                          ' save the textfile content
    Dim hTab             As Long                                            ' hWnd of the tab control
    Dim hEdit            As Long                                            ' hWnd of the edit control
    '                                                                       '
    'Call CopyMemory(udtPropSheetPage, lInitParam, Len(udtPropSheetPage))   ' get the PROPSHEETPAGE struc from memory pointer
    '                                                                       '
    '
    ' HH_INITIALIZE configures HTML Help to run on the same thread as the calling application
    ' you MUST call HtmlHelp() with HH_INITIALIZE (and HH_UNINITIALIZE in OnDestroy) if you
    ' use HtmlHelp() to display help popups! if you dont call it the windows explorer /can/ crash
    Call HtmlHelp(0, vbNullString, HH_INITIALIZE, dwHtmlHelpCookie)
    '
    hTab = GetDlgItem(GetParent(hDialog), IDC_TAB)                          ' get the handle to the tab control
    If hTab <> 0 Then                                                       ' did we get the handle ?
        If GetClientRect(hTab, udtRect) <> 0 Then                           ' get the tab rect
            hEdit = GetDlgItem(hDialog, IDC_EDIT)                           ' get the handle to the edit control
            If hEdit <> 0 Then                                              ' did we get the handle ?
                Call MoveWindow( _
                        hDialog, _
                        5, _
                        5, _
                        udtRect.Right - udtRect.Left - 18, _
                        udtRect.Bottom - udtRect.Top - 35, _
                        1 _
                        )                                                   ' move the dialog
                '                                                           '
                Call MoveWindow( _
                        hEdit, _
                        5, _
                        5, _
                        udtRect.Right - udtRect.Left - 18, _
                        udtRect.Bottom - udtRect.Top - 35, _
                        1 _
                        )                                                   ' move the edit control
            End If                                                          '
        End If                                                              '
    End If                                                                  '
    '                                                                       '
    strText = File_Open(modPropSheet.m_FilePath(1))                         ' read the textfile
    '                                                                       '
    If strText <> "" Then                                                   '
        Control_SetText hDialog, IDC_EDIT, strText                          ' set the text into the edit control
    End If                                                                  '
    '                                                                       '
    OnInitDialog = 1                                                        ' dialog box procedure should return TRUE to direct the system to set the keyboard focus to the first control
End Function

'####################################################################################################
'#####[ OnCommand ]##################################################################################
'####################################################################################################
Private Function OnCommand(hDialog As Long, wNotifyCode As Long, wID As Long, hwndCtl As Long) As Long
    Select Case wID                                                         ' select control id
        Case IDC_EDIT                                                       ' id of the edit control ?
            Select Case wNotifyCode                                         ' select command
                Case EN_UPDATE                                              ' the user has chaned the text
                    PropertySheet_Changed GetParent(hDialog), hDialog       ' enable the "Apply Now" button
            End Select                                                      '
    End Select                                                              '
    '                                                                       '
    OnCommand = 0                                                           ' msdn says we 'should return zero'.
End Function

'####################################################################################################
'#####[ OnNotify ]###################################################################################
'####################################################################################################
Private Function OnNotify(hDialog As Long, idCtrl As Long, lppsn As Long) As Long
    Dim udtPShNotify As PSHNOTIFY                                           ' PSHNOTIFY struct
    Dim strText      As String                                              ' save the text from the edit control
    Dim lResult      As Long                                                ' return value
    '                                                                       '
    Call CopyMemory(udtPShNotify, lppsn, Len(udtPShNotify))                 ' get the PSHNOTIFY struct from memory pointer
    '                                                                       '
    Select Case udtPShNotify.hdr.code                                       ' select notification message
        Case PSN_APPLY                                                      ' "OK" or "Apply Now" was clicked
            strText = Control_GetText(hDialog, IDC_EDIT)                    ' get the text from edit control
            '                                                               '
            On Error Resume Next                                            '
            Kill modPropSheet.m_FilePath(1)                                 ' delete the textfile
            '                                                               '
            If File_Save(modPropSheet.m_FilePath(1), strText) = True Then   ' save the textfile
                lResult = PSNRET_NOERROR                                    ' return no error if successful
            Else                                                            ' else
                lResult = PSNRET_INVALID_NOCHANGEPAGE                       ' dont close the dialog
            End If                                                          '
        'Case PSN_HELP                                                      ' the help button was clicked (the button is only visible if the page was created with PSP_HASHELP flag)
        'Case PSN_SETACTIVE                                                 ' the page was activated
        'Case PSN_KILLACTIVE                                                ' the page was deactivated
        'Case PSN_QUERYCANCEL                                               ' the user has clicked cancel
        Case Else                                                           '
            lResult = 0                                                     ' default return 0
    End Select                                                              '
    '                                                                       '
    Call SetWindowLong(hDialog, DWL_MSGRESULT, lResult)                     ' we MUST set the return code
    '                                                                       '
    OnNotify = lResult                                                      ' return the result
End Function

'####################################################################################################
'#####[ OnHelp ]#####################################################################################
'####################################################################################################
Private Function OnHelp(hDialog As Long, lphi As Long) As Long
    Dim udtHelpInfo As HELPINFO                                             ' HELPINFO struct
    Dim udtHHPopup  As HH_POPUP                                             ' HH_POPUP struct
    Dim sHelpString As String                                               ' save the help string
    Dim lResult     As Long                                                 ' HtmlHelp() return value
    '                                                                       '
    Call CopyMemory(udtHelpInfo, lphi, Len(udtHelpInfo))                    ' get the HELPINFO struct from memory pointer
    '                                                                       '
    Select Case udtHelpInfo.iCtrlId                                         ' select the clicked control
        Case IDC_EDIT:  sHelpString = "Dieses Textfeld zeigt den Inhalt der Datei an."
        Case Else:      sHelpString = "Diesem Element ist keine Hilfe zugeordnet."
    End Select
    '
    With udtHHPopup
        .cbStruct = Len(udtHHPopup)
        .hinst = App.hInstance ' App.hInstance = GetWindowLong(hDialog, GWL_HINSTANCE)
        .idString = 0
        .pszText = sHelpString
        .pt.x = udtHelpInfo.MousePos.x
        .pt.y = udtHelpInfo.MousePos.y
        .clrForeground = -1
        .clrBackground = -1
        .rcMargins.Left = -1
        .rcMargins.Top = -1
        .rcMargins.Right = -1
        .rcMargins.Bottom = -1
        .pszFont = vbNullString
    End With
    '
    ' show help popup
    lResult = HtmlHelp(udtHelpInfo.hItemHandle, vbNullString, HH_DISPLAY_TEXT_POPUP, udtHHPopup)
    '
    OnHelp = 1
End Function

'####################################################################################################
'#####[ OnDestroy ]##################################################################################
'####################################################################################################
Private Function OnDestroy(hDialog As Long) As Long
    '
    ' This command is called to properly shut down HTML Help.
    ' you MUST call HtmlHelp() with HH_UNINITIALIZE (and HH_INITIALIZE in OnInitDialog) if you
    ' use HtmlHelp() to display help popups! if you dont call it the windows explorer /can/ crash
    Call HtmlHelp(0, vbNullString, HH_UNINITIALIZE, dwHtmlHelpCookie)
    '
    OnDestroy = 0
End Function

'####################################################################################################
'#####[ Property Sheet ]#############################################################################
'####################################################################################################
Private Sub PropertySheet_Changed(hPage As Long, hDialog As Long)
    Call SendMessage(hPage, PSM_CHANGED, hDialog, 0&)   ' enable the "Apply Now" button
End Sub

'####################################################################################################
'#####[ Control ]####################################################################################
'####################################################################################################
Private Function Control_GetText(hDialog As Long, nControlID As Long) As String
    Dim sBuffer  As String                                          ' text buffer
    Dim lBuffer  As Long                                            ' buffer size
    Dim lResult  As Long                                            ' return value
    Dim hControl As Long                                            ' control handle
    '                                                               '
    hControl = GetDlgItem(hDialog, nControlID)                      ' get handle to the control
    If hControl <> 0 Then                                           ' did we get the handle
        lBuffer = GetWindowTextLength(hControl)                     ' get len of the control text
        If lBuffer > 0 Then                                         ' len > 0 ?
            sBuffer = String$(lBuffer + 1, vbNullChar)              ' prepare the buffer
            lResult = GetWindowText(hControl, sBuffer, lBuffer + 1) ' get the text
            If lResult > 0 Then                                     ' did we get the text ?
                Control_GetText = Left$(sBuffer, lResult)           ' return the text
            End If
        End If
    End If
End Function

Private Function Control_SetText(hDialog As Long, nControlID As Long, strText As String) As Boolean
    Dim lResult  As Long                                            ' return value
    Dim hControl As Long                                            ' control handle
    '                                                               '
    hControl = GetDlgItem(hDialog, nControlID)                      ' get handle to the control
    If hControl <> 0 Then                                           ' did we get the handle
        lResult = SetWindowText(hControl, strText)                  ' set the text
        If lResult <> 0 Then                                        ' did we set the text ?
            Control_SetText = True                                  ' return true
        End If                                                      '
    End If                                                          '
End Function

'####################################################################################################
'#####[ File_Open ]##################################################################################
'####################################################################################################
Private Function File_Open(strFilePath As String) As String
    Dim strBuff As String                                           ' buffer
    Dim lngSize As Long                                             ' file size
    Dim intFree As Integer                                          ' file handle
    '                                                               '
    Const MAX_SIZE As Long = &H7FFF&                                ' max edit control text len
    '                                                               '
    On Error GoTo ERR_HANDLER                                       ' handle errors
    '                                                               '
    lngSize = FileLen(strFilePath)                                  ' get the file size
    intFree = FreeFile()                                            ' get a free file handle
    '                                                               '
    If lngSize > MAX_SIZE Then                                      ' file is bigger that 64K
        MsgBox "Die Datei ist grer als " & _
               Format(MAX_SIZE, "###,###,###,##0") & _
               " Byte. Die Datei wird nur Teilweise angezeigt!", _
               vbOKOnly Or vbExclamation                            ' show a message
        '
        lngSize = MAX_SIZE                                          ' change the buffer size
    End If                                                          '
    '                                                               '
    strBuff = String$(lngSize, vbNullChar)                          ' prepare the buffer
    '                                                               '
    Open strFilePath For Binary Access Read As #intFree             ' open the file
        Get #intFree, , strBuff                                     ' read the file
    '                                                               '
ERR_HANDLER:                                                        ' error handler
    '                                                               '
    If intFree <> 0 Then                                            ' is the file open ?
        Close #intFree                                              ' close it
        intFree = 0                                                 '
    End If                                                          '
    '                                                               '
    If Err.Number <> 0 Then                                         ' file read error ?
        MsgBox "Fehler " & CStr(Err.Number) & ": " & Err.Description, _
               vbOKOnly Or vbExclamation                            ' show message box
        '                                                           '
        Err.Clear                                                   ' clear the error
    End If                                                          '
    '                                                               '
    File_Open = strBuff                                             ' return the file text
End Function

'####################################################################################################
'#####[ File_Save ]##################################################################################
'####################################################################################################
Private Function File_Save(strFilePath As String, strData As String) As Boolean
    Dim intFree As Integer                                          ' file handle
    Dim blnSave As Boolean                                          ' return value
    '                                                               '
    On Error GoTo ERR_HANDLER                                       ' handle errors
    '                                                               '
    intFree = FreeFile()                                            ' get a free file handle
    '                                                               '
    Open strFilePath For Binary Access Write As #intFree            ' open the file
        Put #intFree, , strData                                     ' write the file
    '                                                               '
    blnSave = True                                                  ' no error occured, return true
    '                                                               '
ERR_HANDLER:                                                        ' error handler
    '                                                               '
    If intFree <> 0 Then                                            ' is the file open ?
        Close #intFree                                              ' close it
        intFree = 0                                                 '
    End If                                                          '
    '                                                               '
    If Err.Number <> 0 Then                                         ' file write error ?
        MsgBox "Fehler " & CStr(Err.Number) & ": " & Err.Description, _
               vbOKOnly Or vbExclamation                            ' show message box
        '                                                           '
        Err.Clear                                                   ' clear the error
    End If                                                          '
    '                                                               '
    File_Save = blnSave                                             ' return true or false
End Function

'####################################################################################################
'#####[ Helper ]#####################################################################################
'####################################################################################################
Private Function HiWord(ByVal Value As Long) As Integer
    HiWord = (Value And &HFFFF0000) \ &HFFFF&
End Function

Private Function LoWord(ByVal Value As Long) As Integer
    If Value And &H8000& Then
        LoWord = Value Or &HFFFF0000
    Else
        LoWord = Value And &HFFFF&
    End If
End Function
